var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from 'echarts-for-react';
import React, { useEffect } from 'react';
var LineChart = function (props) {
    var _a = React.useState('loading'), status = _a[0], setStatus = _a[1];
    var _b = React.useState([]), chartData = _b[0], setChartData = _b[1];
    var getChartDataAsync = function (arg) { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4, props.configuration.fnGetChartDataAsync(arg)];
                case 1:
                    result = _b.sent();
                    setStatus('loaded');
                    setChartData(result);
                    return [3, 3];
                case 2:
                    _a = _b.sent();
                    setStatus('error');
                    setChartData([]);
                    return [3, 3];
                case 3: return [2];
            }
        });
    }); };
    useEffect(function () {
        getChartDataAsync({ id: props.configuration.setup.id });
    }, []);
    if (status === 'loading') {
        if (props.configuration.loadingComponent)
            return props.configuration.loadingComponent;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-loading", children: _jsx("h1", { children: "Loading..." }) }));
    }
    if (status === 'error') {
        if (props.configuration.errorComponent)
            return props.configuration.errorComponent;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-error", children: _jsx("h1", { children: "Error" }) }));
    }
    var serials = new Set();
    var xValues = new Set();
    chartData.forEach(function (item) {
        var _a, _b, _c, _d;
        serials.add(item[(_b = (_a = props.configuration.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field]);
        xValues.add(item[(_d = (_c = props.configuration.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field]);
    });
    var getOption = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12;
        return {
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true,
            },
            title: {
                show: (_c = (_b = (_a = props.configuration.setup.chart) === null || _a === void 0 ? void 0 : _a.title) === null || _b === void 0 ? void 0 : _b.show) !== null && _c !== void 0 ? _c : true,
                text: typeof ((_e = (_d = props.configuration.setup.chart) === null || _d === void 0 ? void 0 : _d.title) === null || _e === void 0 ? void 0 : _e.text) === 'string'
                    ? (_g = (_f = props.configuration.setup.chart) === null || _f === void 0 ? void 0 : _f.title) === null || _g === void 0 ? void 0 : _g.text
                    : typeof props.configuration.setup.title === 'string'
                        ? props.configuration.setup.title
                        : undefined,
                textStyle: {
                    fontSize: ((_k = (_j = (_h = props.configuration.setup.chart) === null || _h === void 0 ? void 0 : _h.title) === null || _j === void 0 ? void 0 : _j.textStyle) === null || _k === void 0 ? void 0 : _k.fontSize) || 14,
                    color: ((_o = (_m = (_l = props.configuration.setup.chart) === null || _l === void 0 ? void 0 : _l.title) === null || _m === void 0 ? void 0 : _m.textStyle) === null || _o === void 0 ? void 0 : _o.color) || '#000',
                },
            },
            legend: {
                show: (_r = (_q = (_p = props.configuration.setup.chart) === null || _p === void 0 ? void 0 : _p.legend) === null || _q === void 0 ? void 0 : _q.show) !== null && _r !== void 0 ? _r : true,
                orient: ((_t = (_s = props.configuration.setup.chart) === null || _s === void 0 ? void 0 : _s.legend) === null || _t === void 0 ? void 0 : _t.orient) || 'horizontal',
                align: ((_v = (_u = props.configuration.setup.chart) === null || _u === void 0 ? void 0 : _u.legend) === null || _v === void 0 ? void 0 : _v.align) || 'auto',
            },
            tooltip: {
                show: (_y = (_x = (_w = props.configuration.setup.chart) === null || _w === void 0 ? void 0 : _w.tooltip) === null || _x === void 0 ? void 0 : _x.show) !== null && _y !== void 0 ? _y : true,
                trigger: ((_0 = (_z = props.configuration.setup.chart) === null || _z === void 0 ? void 0 : _z.tooltip) === null || _0 === void 0 ? void 0 : _0.trigger) || 'item',
                backgroundColor: ((_2 = (_1 = props.configuration.setup.chart) === null || _1 === void 0 ? void 0 : _1.tooltip) === null || _2 === void 0 ? void 0 : _2.backgroundColor) || '#000',
                borderRadius: ((_4 = (_3 = props.configuration.setup.chart) === null || _3 === void 0 ? void 0 : _3.tooltip) === null || _4 === void 0 ? void 0 : _4.borderRadius) || 0,
                textStyle: {
                    fontSize: ((_7 = (_6 = (_5 = props.configuration.setup.chart) === null || _5 === void 0 ? void 0 : _5.tooltip) === null || _6 === void 0 ? void 0 : _6.textStyle) === null || _7 === void 0 ? void 0 : _7.fontSize) || 'normal',
                    color: ((_10 = (_9 = (_8 = props.configuration.setup.chart) === null || _8 === void 0 ? void 0 : _8.tooltip) === null || _9 === void 0 ? void 0 : _9.textStyle) === null || _10 === void 0 ? void 0 : _10.color) || '#fff',
                },
            },
            dataset: {
                source: __spreadArray([
                    __spreadArray([(_12 = (_11 = props.configuration.setup.chart) === null || _11 === void 0 ? void 0 : _11.seri) === null || _12 === void 0 ? void 0 : _12.field], Array.from(serials), true)
                ], Array.from(xValues).map(function (xValue) { return __spreadArray([
                    xValue
                ], Array.from(serials).map(function (serial) {
                    var _a, _b, _c;
                    return ((_a = chartData.find(function (item) {
                        var _a, _b, _c, _d;
                        return item[(_b = (_a = props.configuration.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field] === serial &&
                            item[(_d = (_c = props.configuration.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field] === xValue;
                    })) === null || _a === void 0 ? void 0 : _a[(_c = (_b = props.configuration.setup.chart) === null || _b === void 0 ? void 0 : _b.y_axis) === null || _c === void 0 ? void 0 : _c.field]) || 0;
                }), true); }), true),
            },
            xAxis: { type: 'category' },
            yAxis: { type: 'value' },
            series: props.configuration.setup.type === 'step-line-chart'
                ? Array.from(serials).map(function () {
                    return { type: 'line', step: 'middle' };
                })
                : Array.from(serials).map(function (value, index) {
                    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
                    return {
                        type: 'line',
                        lineStyle: {
                            color: (_e = (_d = (_c = (_b = (_a = props.configuration.setup.chart) === null || _a === void 0 ? void 0 : _a.item_styles) === null || _b === void 0 ? void 0 : _b[index]) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.line_color) !== null && _e !== void 0 ? _e : '#000',
                        },
                        smooth: (_k = (_j = (_h = (_g = (_f = props.configuration.setup.chart) === null || _f === void 0 ? void 0 : _f.item_styles) === null || _g === void 0 ? void 0 : _g[index]) === null || _h === void 0 ? void 0 : _h.style) === null || _j === void 0 ? void 0 : _j.smooth) !== null && _k !== void 0 ? _k : false,
                    };
                }),
        };
    };
    return _jsx(ReactECharts, { option: getOption() });
};
export default LineChart;
