var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect } from 'react';
import BarChart from './charts/BarChart.js';
import LineChart from './charts/LineChart.js';
import PieChart from './charts/PieChart.js';
import StackChart from './charts/StackChart.js';
export * from './types.js';
var SDashboard = function (props) {
    var _a = React.useState('loading'), status = _a[0], setStatus = _a[1];
    var _b = React.useState([]), dashboardItems = _b[0], setDashboardItems = _b[1];
    var getItemsAsync = function () { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4, props.configuration.fnGetItemsAsync({
                            dashboardCode: props.dashboardCode,
                        })];
                case 1:
                    result = _b.sent();
                    setStatus('loaded');
                    setDashboardItems(result);
                    return [3, 3];
                case 2:
                    _a = _b.sent();
                    setStatus('error');
                    setDashboardItems([]);
                    return [3, 3];
                case 3: return [2];
            }
        });
    }); };
    useEffect(function () {
        getItemsAsync();
    }, []);
    if (status === 'loading') {
        if (props.configuration.loadingComponent)
            return props.configuration.loadingComponent;
        return (_jsx("div", { className: "s-dashboard s-dashboard-loading", children: _jsx("h1", { children: "Loading..." }) }));
    }
    if (status === 'error') {
        if (props.configuration.errorComponent)
            return props.configuration.errorComponent;
        return (_jsx("div", { className: "s-dashboard s-dashboard-error", children: _jsx("h1", { children: "Error" }) }));
    }
    return (_jsxs("div", { className: "s-dashboard s-dashboard-loaded", style: {
            gridTemplateColumns: "repeat(".concat(props.grid_column || 2, ", 1fr)"),
            background: props.background || 'transparent',
        }, children: [props.title && _jsx("h1", { className: "s-dashboard-title", children: props.title }), dashboardItems.map(function (item, index) {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z;
                switch (item.setup.type) {
                    case 'vertical-bar-chart':
                    case 'horizontal-bar-chart':
                        return (_jsxs("div", { className: "s-dasboard__item", style: {
                                gridColumn: "".concat(Number(item.setup.x) + 1, " / span ").concat(item.setup.width),
                                gridRow: "".concat(Number(item.setup.y) + 1, " / span ").concat(item.setup.height),
                            }, children: [((_a = item.setup.chart) === null || _a === void 0 ? void 0 : _a.title) && (_jsx("div", { className: "s-dashboard__title", style: {
                                        color: ((_b = item.setup.chart.title.textStyle) === null || _b === void 0 ? void 0 : _b.color) || '#000',
                                        fontSize: ((_c = item.setup.chart.title.textStyle) === null || _c === void 0 ? void 0 : _c.color) || 14,
                                    }, children: _jsx("p", { className: "s-dashboard__title--text", children: typeof item.setup.chart.title.text === 'string'
                                            ? item.setup.chart.title.text
                                            : typeof item.setup.title === 'string'
                                                ? item.setup.title
                                                : '' }) })), _jsx(BarChart, { configuration: {
                                        fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                                        setup: item.setup,
                                        loadingComponent: props.configuration.loadingComponentChartItem,
                                        errorComponent: props.configuration.errorComponentChartItem,
                                    } }, index), ((_d = item.setup.extraData) === null || _d === void 0 ? void 0 : _d.compare) && (_jsxs("div", { className: "s-dashboard__footer", children: [((_e = item.setup.extraData.compare) === null || _e === void 0 ? void 0 : _e.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: item.setup.extraData.compare.status })), ((_f = item.setup.extraData.compare) === null || _f === void 0 ? void 0 : _f.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: item.setup.extraData.compare.value }))] }))] }, index));
                    case 'line-chart':
                    case 'step-line-chart':
                        return (_jsxs("div", { className: "s-dasboard__item", style: {
                                gridColumn: "".concat(Number(item.setup.x) + 1, " / span ").concat(item.setup.width),
                                gridRow: "".concat(Number(item.setup.y) + 1, " / span ").concat(item.setup.height),
                            }, children: [((_g = item.setup.chart) === null || _g === void 0 ? void 0 : _g.title) && (_jsx("div", { className: "s-dashboard__title", style: {
                                        color: ((_h = item.setup.chart.title.textStyle) === null || _h === void 0 ? void 0 : _h.color) || '#000',
                                        fontSize: ((_j = item.setup.chart.title.textStyle) === null || _j === void 0 ? void 0 : _j.color) || 14,
                                    }, children: _jsx("p", { className: "s-dashboard__title--text", children: typeof item.setup.chart.title.text === 'string'
                                            ? item.setup.chart.title.text
                                            : typeof item.setup.title === 'string'
                                                ? item.setup.title
                                                : '' }) })), _jsx(LineChart, { configuration: {
                                        fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                                        setup: item.setup,
                                        loadingComponent: props.configuration.loadingComponentChartItem,
                                        errorComponent: props.configuration.errorComponentChartItem,
                                    } }, index), ((_k = item.setup.extraData) === null || _k === void 0 ? void 0 : _k.compare) && (_jsxs("div", { className: "s-dashboard__footer", children: [((_l = item.setup.extraData.compare) === null || _l === void 0 ? void 0 : _l.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: item.setup.extraData.compare.status })), ((_m = item.setup.extraData.compare) === null || _m === void 0 ? void 0 : _m.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: item.setup.extraData.compare.value }))] }))] }, index));
                    case 'pie-chart':
                        return (_jsxs("div", { className: "s-dasboard__item", style: {
                                gridColumn: "".concat(Number(item.setup.x) + 1, " / span ").concat(item.setup.width),
                                gridRow: "".concat(Number(item.setup.y) + 1, " / span ").concat(item.setup.height),
                            }, children: [((_o = item.setup.chart) === null || _o === void 0 ? void 0 : _o.title) && (_jsx("div", { className: "s-dashboard__title", style: {
                                        color: ((_p = item.setup.chart.title.textStyle) === null || _p === void 0 ? void 0 : _p.color) || '#000',
                                        fontSize: ((_q = item.setup.chart.title.textStyle) === null || _q === void 0 ? void 0 : _q.color) || 14,
                                    }, children: _jsx("p", { className: "s-dashboard__title--text", children: typeof item.setup.chart.title.text === 'string'
                                            ? item.setup.chart.title.text
                                            : typeof item.setup.title === 'string'
                                                ? item.setup.title
                                                : '' }) })), _jsx(PieChart, { configuration: {
                                        fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                                        setup: item.setup,
                                        loadingComponent: props.configuration.loadingComponentChartItem,
                                        errorComponent: props.configuration.errorComponentChartItem,
                                    } }, index), ((_r = item.setup.extraData) === null || _r === void 0 ? void 0 : _r.compare) && (_jsxs("div", { className: "s-dashboard__footer", children: [((_s = item.setup.extraData.compare) === null || _s === void 0 ? void 0 : _s.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: item.setup.extraData.compare.status })), ((_t = item.setup.extraData.compare) === null || _t === void 0 ? void 0 : _t.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: item.setup.extraData.compare.value }))] }))] }, index));
                    case 'stack-area-chart':
                    case 'stack-bar-chart':
                        return (_jsxs("div", { className: "s-dasboard__item", style: {
                                gridColumn: "".concat(Number(item.setup.x) + 1, " / span ").concat(item.setup.width),
                                gridRow: "".concat(Number(item.setup.y) + 1, " / span ").concat(item.setup.height),
                            }, children: [((_u = item.setup.chart) === null || _u === void 0 ? void 0 : _u.title) && (_jsx("div", { className: "s-dashboard__title", style: {
                                        color: ((_v = item.setup.chart.title.textStyle) === null || _v === void 0 ? void 0 : _v.color) || '#000',
                                        fontSize: ((_w = item.setup.chart.title.textStyle) === null || _w === void 0 ? void 0 : _w.color) || 14,
                                    }, children: _jsx("p", { className: "s-dashboard__title--text", children: typeof item.setup.chart.title.text === 'string'
                                            ? item.setup.chart.title.text
                                            : typeof item.setup.title === 'string'
                                                ? item.setup.title
                                                : '' }) })), _jsx(StackChart, { configuration: {
                                        fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                                        setup: item.setup,
                                        loadingComponent: props.configuration.loadingComponentChartItem,
                                        errorComponent: props.configuration.errorComponentChartItem,
                                    } }, index), ((_x = item.setup.extraData) === null || _x === void 0 ? void 0 : _x.compare) && (_jsxs("div", { className: "s-dashboard__footer", children: [((_y = item.setup.extraData.compare) === null || _y === void 0 ? void 0 : _y.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: item.setup.extraData.compare.status })), ((_z = item.setup.extraData.compare) === null || _z === void 0 ? void 0 : _z.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: item.setup.extraData.compare.value }))] }))] }, index));
                    default:
                        return _jsxs("div", { children: ["Unknown chart type: ", JSON.stringify(item.setup)] }, index);
                }
            })] }));
};
export default SDashboard;
